"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Calendario = /** @class */ (function () {
    function Calendario(mes, listDiaSi, listDiaNo, defaultDate, selectedDate) {
        this.mes = mes;
        this.listDiaSi = listDiaSi;
        this.listDiaNo = listDiaNo;
        this.defaultDate = defaultDate;
        this.selectedDate = selectedDate;
    }
    Calendario.newObject = function () {
        return new Calendario(null, null, null, null, null);
    };
    Calendario.prototype.hayDiasDisponibles = function () {
        return this.listDiaSi && this.listDiaSi.length > 0;
    };
    Calendario.locale = function (idioma) {
        return Calendario.locales[idioma.value];
    };
    Calendario.locales = {
        es: {
            firstDayOfWeek: 1,
            dayNames: ["Domingo", "Lunes", "Martes", "Miércoles", "Jueves", "Viernes", "Sábado"],
            dayNamesShort: ["Dom", "Lun", "Mar", "Mié", "Jue", "Vie", "Sáb"],
            dayNamesMin: ["D", "L", "M", "X", "J", "V", "S"],
            monthNames: [
                "Enero",
                "Febrero",
                "Marzo",
                "Abril",
                "Mayo",
                "Junio",
                "Julio",
                "Agosto",
                "Septiembre",
                "Octubre",
                "Noviembre",
                "Diciembre"
            ],
            monthNamesShort: ["Ene", "Feb", "Mar", "Abr", "May", "Jun", "Jul", "Ago", "Sep", "Oct", "Nov", "Dic"]
        },
        ca: {
            firstDayOfWeek: 1,
            dayNames: ["Diumenge", "Dilluns", "Dimarts", "Dimecres", "Dijous", "Divendres", "Dissabte"],
            dayNamesShort: ["DG", "DL", "DT", "DM", "DJ", "DV", "DS"],
            dayNamesMin: ["DG", "DL", "DT", "DM", "DJ", "DV", "DS"],
            monthNames: [
                "Gener",
                "Febrer",
                "Març",
                "Abril",
                "Maig",
                "Juny",
                "Juliol",
                "Agost",
                "Setembre",
                "Octubre",
                "Novembre",
                "Desembre"
            ],
            monthNamesShort: ["Gen", "Feb", "Mar", "Abr", "Mai", "Jun", "Jul", "Ago", "Set", "Oct", "Nov", "Des"]
        }
    };
    return Calendario;
}());
exports.Calendario = Calendario;
//# sourceMappingURL=calendario.js.map