"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var operators_1 = require("rxjs/operators");
var campanya_service_1 = require("../service/campanya.service");
var constants_class_1 = require("../../common/constants-class");
var ConsultarCitaGuard = /** @class */ (function () {
    function ConsultarCitaGuard(campanyaService, router, activatedRoute) {
        this.campanyaService = campanyaService;
        this.router = router;
        this.activatedRoute = activatedRoute;
        this.campanyaId = constants_class_1.ContantsClass.ID_CAMPANYA;
    }
    ConsultarCitaGuard.prototype.canActivate = function (route, state) {
        var url = state.url;
        var alternativeUrl = constants_class_1.ContantsClass.URL_RESERVAR_CITA;
        var lang = route.queryParams["lang"] || route.params["lang"] || navigator.language;
        return this.checkPermiteConsultarCita(alternativeUrl, lang);
    };
    ConsultarCitaGuard.prototype.checkPermiteConsultarCita = function (alternativeUrl, lang) {
        var _this = this;
        return this.campanyaService.findCampanya(this.campanyaId).pipe(operators_1.map(function (result) {
            if (result) {
                var campanya = result;
                var permite = campanya && campanya.permiteConsultarCita;
                console.log("permiteConsultarCita: " + permite);
                if (!permite) {
                    var myRoute = lang ? [alternativeUrl, { lang: lang }] : [alternativeUrl];
                    _this.router.navigate(myRoute);
                }
            }
            return true;
        }));
    };
    ConsultarCitaGuard = __decorate([
        core_1.Injectable(),
        __metadata("design:paramtypes", [campanya_service_1.CampanyaService, router_1.Router, router_1.ActivatedRoute])
    ], ConsultarCitaGuard);
    return ConsultarCitaGuard;
}());
exports.ConsultarCitaGuard = ConsultarCitaGuard;
//# sourceMappingURL=consultar-cita-guard.service.js.map