"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var peticion_cita_1 = require("../../common/data/peticion-cita");
var reservar_cita_paso_1 = require("./reservar-cita-paso");
var bitcitaweb_utils_1 = require("../../shared/utils/bitcitaweb-utils");
var campanya_service_1 = require("../../common/service/campanya.service");
var ResumenCitaComponent = /** @class */ (function (_super) {
    __extends(ResumenCitaComponent, _super);
    function ResumenCitaComponent(campanyaService) {
        var _this = _super.call(this, "ResumenCitaComponent", campanyaService) || this;
        _this.campanyaService = campanyaService;
        // Objeto peticion cita previo a la confirmacion de la cita
        // Este componente (resumen de la cita) puede mostrarse antes de confirmarla, y no todos los datos existen en el objeto Resumen
        _this.peticionSinConfirmar = null;
        _this.campos = campanyaService.getCampos();
        return _this;
    }
    ResumenCitaComponent.prototype.formatoValorCampo = function (value) {
        return bitcitaweb_utils_1.BitcitaWebUtils.formatoValorCampo(value);
    };
    ResumenCitaComponent.prototype.getCampo = function (dominio) {
        return this.campos && this.campos.find(function (campo) { return campo.campoId == dominio.campoId; });
    };
    __decorate([
        core_1.Input(),
        __metadata("design:type", peticion_cita_1.PeticionCita)
    ], ResumenCitaComponent.prototype, "peticionSinConfirmar", void 0);
    ResumenCitaComponent = __decorate([
        core_1.Component({
            selector: "bci-resumen-cita",
            template: "\n    <div class=\"paso\" [style.display]=\"visible?'block':'none'\">\n        <h4 class=\"importante\" *ngIf=\"!peticionSinConfirmar\"><span class=\"fa fa-exclamation-circle\"></span>&nbsp;&nbsp;<span translate=\"titulo.importanteRecordar\">IMPORTANT RECORDI</span></h4>\n\n        <!-- ng-template #ResumenCitaCustom><ng-content select=\"[ResumenCitaCustom]\"></ng-content></ng-template>\n        <ng-container *ngTemplateOutlet=\"ResumenCitaCustom\"></ng-container -->\n        <ng-container *ngIf=\"!peticionSinConfirmar && textoResumenCita\">\n            <div class=\"contenedor-texto-dinamico ql-editor\">\n                <div class=\"row\">\n                    <div [innerHTML]=\"textoResumenCita | sanitizeInnerHtml\" class=\"col-sm-12\"></div>\n                </div>\n            </div>\n        </ng-container>\n        \n        <h4><span class=\"fa fa-calendar-check-o\"></span>&nbsp;&nbsp;<span translate=\"subtitulo.datosReserva\">Dades de la reserva</span></h4>\n        <div class=\"alert alert-info\">\n            <div class=\"row\">\n                <div class=\"col-xs-5 col-sm-3 text-right negrita\" translate=\"dato.servicio\">Servei</div>\n                <div class=\"col-xs-7 col-sm-9 text-left\">{{resumen.servicioNombre}}</div>\n            </div>\n            <div class=\"row\">\n                <div class=\"col-xs-5 col-sm-3 text-right negrita\" translate=\"dato.sitio\">Lloc</div>\n                <div class=\"col-xs-7 col-sm-9 text-left\">{{resumen.sitioNombre}}</div>\n            </div>\n            <div class=\"row\">\n                <div class=\"col-xs-5 col-sm-3 text-right negrita\" translate=\"dato.entidad\">Oficina</div>\n                <div class=\"col-xs-7 col-sm-9 text-left\">{{resumen.entidadNombre}}<span *ngIf=\"resumen.entidadDireccion\">, {{resumen.entidadDireccion}}</span></div>\n            </div>\n            <!-- se muestra el recurso si el servicio permite la seleccion de recurso y se ha seleccionado uno (es opcional) -->\n            <div class=\"row\" *ngIf=\"resumen.servicio && resumen.servicio.permiteSeleccionRecurso && resumen.recursoNombre && \n                                    ((peticion && peticion.recursoId) || (peticionSinConfirmar && peticionSinConfirmar.recursoId))\">\n                <div class=\"col-xs-5 col-sm-3 text-right negrita\" translate=\"dato.recurso\">Tècnic</div>\n                <div class=\"col-xs-7 col-sm-9 text-left\">{{resumen.recursoNombre}}</div>\n            </div>\n            <div class=\"row\">\n                <div class=\"col-xs-5 col-sm-3 text-right negrita\" translate=\"dato.fechaCita\">Data de la cita</div>\n                <div class=\"col-xs-7 col-sm-9 text-left\">{{peticionSinConfirmar ? peticionSinConfirmar.dia : resumen.dia}} <span translate=\"info.aLas\">a les</span> {{peticionSinConfirmar ? peticionSinConfirmar.hora : resumen.hora}}</div>\n            </div>\n        </div>\n\n        <!-- campos del solicitante -->\n        <h4><span class=\"fa fa-user-circle-o\"></span>&nbsp;&nbsp;<span translate=\"subtitulo.datosSolicitante\">Dades del sol·licitant</span></h4>\n        <div *ngIf=\"resumen && resumen.valores\" class=\"alert alert-info\">\n            <ng-container *ngFor=\"let valor of resumen.valores\">\n                <div class=\"row\" *ngIf=\"!getCampo(valor) || getCampo(valor).checkForm != 'siNo'\">\n                    <div class=\"col-xs-5 col-sm-3 text-right negrita\">{{valor.label}}</div>\n                    <div class=\"col-xs-7 col-sm-9 text-left\">{{formatoValorCampo(valor.value)}}</div>\n                </div>\n            </ng-container>\n        </div>\n    \n        <ng-container *ngIf=\"!peticionSinConfirmar\">\n        <div class=\"row hidden-print\">\n            <div class=\"col-sm-12\">\n                <button class=\"btn btn-default pull-right\" onclick=\"window.print();\"><span translate=\"btn.imprimir\">Imprimeix</span>&nbsp;&nbsp;<span class=\"fa fa-print\"></span></button>\n            </div>\n        </div>\n        <div class=\"row hidden-print\">\n            <div class=\"col-sm-12\">\n                <div class=\"btn-navegar\">\n                    <button class=\"btn btn-upload pull-right\" (click)=\"goToPasoSiguiente();\"><span class=\"fa fa-chevron-left\"></span>&nbsp;&nbsp;<span translate=\"btn.reiniciar\">Inicia una nova reserva</span></button>\n                </div>\n            </div>\n        </div>\n        </ng-container>\n    </div>\n  "
        }),
        __metadata("design:paramtypes", [campanya_service_1.CampanyaService])
    ], ResumenCitaComponent);
    return ResumenCitaComponent;
}(reservar_cita_paso_1.ReservarCitaPaso));
exports.ResumenCitaComponent = ResumenCitaComponent;
//# sourceMappingURL=4-resumen-cita.component.js.map