"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var core_2 = require("@ngx-translate/core");
var peticion_cita_1 = require("../../common/data/peticion-cita");
var resumen_cita_1 = require("../../common/data/resumen-cita");
/**
 * Componente resumen de la reserva.
 * Muestra en ventana emergente el resumen de la reserva.
 */
var ResumencitaConfirmarFormComponent = /** @class */ (function () {
    function ResumencitaConfirmarFormComponent(translate) {
        var _this = this;
        this.translate = translate;
        this.display = false;
        this.onSave = new core_1.EventEmitter();
        this.onClose = new core_1.EventEmitter();
        this.titulo = "Reserva de cita";
        this.translate.get("titulo.reservarCita").subscribe(function (r) {
            _this.titulo = r;
        });
    }
    ResumencitaConfirmarFormComponent.prototype.closeForm = function () {
        this.onClose.emit(true);
    };
    ResumencitaConfirmarFormComponent.prototype.saveItem = function () {
        this.onSave.emit(true);
    };
    __decorate([
        core_1.Input(),
        __metadata("design:type", resumen_cita_1.ResumenCita)
    ], ResumencitaConfirmarFormComponent.prototype, "resumen", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", peticion_cita_1.PeticionCita)
    ], ResumencitaConfirmarFormComponent.prototype, "peticion", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], ResumencitaConfirmarFormComponent.prototype, "display", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], ResumencitaConfirmarFormComponent.prototype, "onSave", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], ResumencitaConfirmarFormComponent.prototype, "onClose", void 0);
    ResumencitaConfirmarFormComponent = __decorate([
        core_1.Component({
            selector: "resumen-cita-confirmar-form",
            template: "\n    <p-dialog *ngIf=\"resumen && display\" class=\"scroll-y scroll-300\" width=\"600\" header=\"{{titulo}}\" resizable=\"false\" [visible]=\"display\" [modal]=\"true\" (onHide)=\"closeForm()\" showEffect=\"fade\">\n        <h5><span translate=\"titulo.confirmarCita\">Es reservarà la cita amb les següents dades:</span></h5>\n        <bci-resumen-cita [resumen]=\"resumen\" [peticionSinConfirmar]=\"peticion\" visible=\"true\"></bci-resumen-cita>\n        <p-footer>\n            <div class=\"ui-dialog-buttonpane ui-widget-content ui-helper-clearfix\">\n                <button class=\"btn btn-success\" (click)=\"closeForm()\"><span translate=\"btn.cancelar\">Cancel·la</span></button>\n                <button class=\"btn btn-primary\" (click)=\"saveItem()\"><span translate=\"btn.confirmar\">Confirma</span>&nbsp;&nbsp;<span class=\"fa fa fa-chevron-right\"></span></button> \n            </div>\n        </p-footer>\n    </p-dialog>\n  "
        }),
        __metadata("design:paramtypes", [core_2.TranslateService])
    ], ResumencitaConfirmarFormComponent);
    return ResumencitaConfirmarFormComponent;
}());
exports.ResumencitaConfirmarFormComponent = ResumencitaConfirmarFormComponent;
//# sourceMappingURL=resumen-cita-confirmar-form.component.js.map