"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var moment = require("moment-mini-ts");
//import moment = require("moment");  versión lógica por la forma en que se exporta moment desde moment.d.ts
var rxjs_1 = require("rxjs");
var domain_1 = require("../data/domain");
var GeneralUtils = /** @class */ (function () {
    function GeneralUtils() {
        this.observableLoadingSource = new rxjs_1.Subject();
        this.observableLoading = this.observableLoadingSource.asObservable();
    }
    GeneralUtils_1 = GeneralUtils;
    GeneralUtils.prototype.startLoading = function () {
        // console.log("start loading");
        this.observableLoadingSource.next("start");
    };
    GeneralUtils.prototype.stopLoading = function () {
        // console.log("stop loading");
        this.observableLoadingSource.next("stop");
    };
    GeneralUtils.getTwoDigits = function (digit) {
        if (digit < 10) {
            return "0" + digit;
        }
        else {
            return "" + digit;
        }
    };
    GeneralUtils.getPathFromURL = function (segments) {
        var path = "";
        for (var _i = 0, segments_1 = segments; _i < segments_1.length; _i++) {
            var seg = segments_1[_i];
            path += seg.path;
            path += "/";
        }
        return path;
    };
    GeneralUtils.buildNombreCompleto = function (obj) {
        var str = "";
        if (obj.nombre)
            str += obj.nombre;
        if (obj.apellido1)
            str += (str.length > 0 ? " " : "") + obj.apellido1;
        if (obj.apellido2)
            str += (str.length > 0 ? " " : "") + obj.apellido2;
        return str;
    };
    GeneralUtils.getTodayAsString = function (format) {
        if (format === void 0) { format = GeneralUtils_1.FORMAT_SHORT_DATE; }
        return moment(new Date()).format(format);
    };
    GeneralUtils.getDateAsString = function (fecha, format) {
        if (format === void 0) { format = GeneralUtils_1.FORMAT_SHORT_DATE; }
        return moment(fecha).format(format);
    };
    GeneralUtils.getStringAsDate = function (fecha, format) {
        if (format === void 0) { format = GeneralUtils_1.FORMAT_SHORT_DATE; }
        return moment(fecha, format).toDate();
    };
    GeneralUtils.getDateTimeAsString = function (fecha, format) {
        if (format === void 0) { format = GeneralUtils_1.FORMAT_LONG_DATE; }
        return moment(fecha).format(format);
    };
    GeneralUtils.getTimeAsString = function (fecha, format) {
        if (format === void 0) { format = GeneralUtils_1.FORMAT_SHORT_TIME; }
        return moment(fecha).format(format);
    };
    GeneralUtils.stringToDate = function (fString) {
        return moment(fString).toDate();
    };
    GeneralUtils.stringShortToDate = function (fString) {
        return moment(fString, "DD/MM/YYYY").toDate();
    };
    GeneralUtils.stringToTime = function (tString) {
        return moment(tString, "HH:mm").toDate();
    };
    GeneralUtils.getTimeFromDateString = function (fecha) {
        return moment(fecha).format(GeneralUtils_1.FORMAT_SHORT_TIME);
    };
    GeneralUtils.getWithDaysOffset = function (offset) {
        if (offset === void 0) { offset = 0; }
        return moment().add(offset, "days").format(GeneralUtils_1.FORMAT_SHORT_DATE);
    };
    GeneralUtils.getFirstDayOfCurrentMonth = function () {
        return moment().startOf("month").format(GeneralUtils_1.FORMAT_SHORT_DATE);
    };
    GeneralUtils.getLastDayOfCurrentMonth = function () {
        return moment().endOf("month").format(GeneralUtils_1.FORMAT_SHORT_DATE);
    };
    GeneralUtils.fechaInicioDespuesIgualFechaFin = function (fechaInicio, fechaFin) {
        if (fechaInicio && fechaFin) {
            return GeneralUtils_1.stringShortToDate(fechaInicio) > GeneralUtils_1.stringShortToDate(fechaFin);
        }
        return false;
    };
    GeneralUtils.horaInicioDespuesHoraFin = function (horaInicio, horaFin) {
        if (horaInicio && horaFin) {
            return GeneralUtils_1.stringToTime(horaInicio) > GeneralUtils_1.stringToTime(horaFin);
        }
        return false;
    };
    GeneralUtils.fechaEnRango = function (fecha, fechaInicio, fechaFin) {
        if (fecha) {
            var fechaDate = GeneralUtils_1.stringShortToDate(fecha);
            var output = !((fechaInicio && fechaDate < GeneralUtils_1.stringShortToDate(fechaInicio)) ||
                (fechaFin && fechaDate > GeneralUtils_1.stringShortToDate(fechaFin)));
            return output;
        }
        return false;
    };
    GeneralUtils.addOpcionVacia = function (lista, texto) {
        var nLista = lista.slice();
        nLista.unshift(new domain_1.Domain(null, texto ? texto : ""));
        return nLista;
    };
    GeneralUtils.getOptionText = function (list, id) {
        for (var _i = 0, list_1 = list; _i < list_1.length; _i++) {
            var d = list_1[_i];
            if (+d.value == id) {
                return d.label;
            }
        }
        return "-";
    };
    var GeneralUtils_1;
    GeneralUtils.FORMAT_SHORT_DATE = "DD/MM/YYYY";
    GeneralUtils.FORMAT_LONG_DATE = "DD/MM/YYYY HH:mm";
    GeneralUtils.FORMAT_SHORT_TIME = "HH:mm";
    GeneralUtils.FORMAT_SHORT_SECONDS_TIME = "HH:mm:ss";
    GeneralUtils = GeneralUtils_1 = __decorate([
        core_1.Injectable(),
        __metadata("design:paramtypes", [])
    ], GeneralUtils);
    return GeneralUtils;
}());
exports.GeneralUtils = GeneralUtils;
//# sourceMappingURL=general-utils.service.js.map